"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var VuexModule = (function () {
    function VuexModule(module) {
        this.actions = module.actions;
        this.mutations = module.mutations;
        this.state = module.state;
        this.getters = module.getters;
        this.namespaced = module.namespaced;
        this.modules = module.modules;
    }
    return VuexModule;
}());
exports.VuexModule = VuexModule;
function moduleDecoratorFactory(modOrOpt) {
    return function (target) {
        var module = target;
        var state = new (module.prototype.constructor)({});
        if (!module.state) {
            module.state = {};
        }
        module.namespaced = modOrOpt && modOrOpt.namespaced;
        Object.keys(state).forEach(function (key) {
            if (state.hasOwnProperty(key) && typeof state[key] !== 'function') {
                module.state[key] = state[key];
            }
        });
    };
}
function Module(modOrOpt) {
    if (typeof modOrOpt === 'function') {
        moduleDecoratorFactory({})(modOrOpt);
    }
    else {
        return moduleDecoratorFactory(modOrOpt);
    }
}
exports.Module = Module;
//# sourceMappingURL=module.js.map